﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
#Event: Select(ID As String, Open As Boolean)
#Event: LongClick(ID As String, Open As Boolean)

#DesignerProperty: Key: KeepAspectRatio, DisplayName: KeepAspectRatio, FieldType: Boolean, DefaultValue: False
'#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Text color

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	
	Type TypeImage(bmp As B4XBitmap,ID As String, Vw As B4XView, Open As Boolean)
	'Animation duration
	Public MovTime As Int = 100
	Public KeepAspectRatio As Boolean = False
	Private Sc As B4XView
	
	Private Large As Float = 80dip 
	Private ListB4XBitmap As List
	
	
	#IF B4J
		Private nSc As ScrollPane
		Private Pn As Pane
		Private SingleClick As Boolean = True
	#Else IF B4A
		Private nSc As ScrollView
	#Else If B4i
		Private nSc As ScrollView
	#End If
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	ListB4XBitmap.Initialize
	
	#IF B4J
		Pn.Initialize("")
		nSc.Initialize("")
		nSc.InnerNode=Pn
		nSc.SetHScrollVisibility("NEVER")
	#Else IF B4A
		nSc.Initialize(1000dip)
	#Else If B4i
		nSc.Initialize("",1000dip,1000dip)
	#End If
	Sc=nSc
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
    mBase.Tag = Me 
	mBase.AddView(Sc,0,0,mBase.Width,mBase.Height)
	Sc.ScrollViewContentWidth=Sc.Width
	
	KeepAspectRatio=Props.Get("KeepAspectRatio")
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	Sc.Width=Width
	Sc.Height=Height
	Sc.ScrollViewContentWidth=Width
	Invalidate
End Sub

Public Sub Clear
	For Each Item As TypeImage In ListB4XBitmap
		Item.Vw.RemoveViewFromParent
	Next
	ListB4XBitmap.Clear
End Sub

'Number of images
Public Sub getSize As Int
	Return ListB4XBitmap.Size
End Sub

Public Sub AddImage(ID As String,bmp As B4XBitmap)
	Dim N As TypeImage

	N.Initialize
	N.bmp=bmp
	N.Vw=Null
	N.Open=False
	N.ID=ID
	
	ListB4XBitmap.Add(N)
	Invalidate
End Sub

Public Sub AddUrlImage(ID As String, url As String)
	Dim N As TypeImage
	Dim j As HttpJob
	
	j.Initialize("", Me)
	j.Download(url)
	Wait For (j) JobDone(j As HttpJob)
	If j.Success Then
		N.Initialize
		N.bmp=j.GetBitmap
		N.Vw=Null
		N.ID=ID
		N.Open=False
	
		ListB4XBitmap.Add(N)
		Invalidate
	End If
	j.Release
End Sub

'Returns the image associated with the ID
Public Sub GetImageID(ID As String) As B4XBitmap
	For Each Item As TypeImage In ListB4XBitmap
		If Item.ID=ID Then Return Item.bmp
	Next
	Return Null
End Sub

'Returns the ID of the image that is stretched, null if all are closed
Public Sub GetOpenID As String
	For Each Item As TypeImage In ListB4XBitmap
		If Item.Open Then Return Item.id
	Next
	Return Null
End Sub

Public Sub GetID(Position As Int) As String
	If Position>-1 And Position<ListB4XBitmap.Size Then
		Dim Item As TypeImage=ListB4XBitmap.Get(Position)
		Return Item.ID
	End If
	
	Return Null
End Sub

Public Sub Invalidate
	Dim LastItem As TypeImage
	Dim Col As Int = 0
	Dim Row As Int = 0
	Dim MaxCol As Int = Sc.ScrollViewContentWidth/Large
	Dim OpenCol As Int = -100
	Dim OpenRow As Int = -100
	Dim LastRow As Int = 0
	Dim Factor As Int = 1
	
	For Each Item As TypeImage In ListB4XBitmap
		' Exist'
		If Not(Item.Vw.IsInitialized) Then
			Dim Imv As ImageView
			Imv.Initialize("Image")

			Item.Vw=Imv
			Item.Vw.Tag=Item
			
			#IF B4J
				Pn.AddNode(Imv,0,0,1,1)
			#Else IF B4A or B4i
				nSc.Panel.AddView(Imv,0,0,1,1)
			#End If
		End If
		
		' If Image is Giant
		If Item.Open Then
			If Col=MaxCol-1 Then ' if Giant in Last Plase go prev
				OpenCol=Col-1
				OpenRow=Row
				' find first free place
				Do While Collision(Row,Col,OpenRow,OpenCol)
					Col=Col+1
					If Col>=MaxCol Then
						Col=0
						Row=Row+1
					End If
				Loop
				' move prev image to first free place
				if LastItem.IsInitialized then LastItem.Vw.SetLayoutAnimated(MovTime,Col*Large,Row*Large,Large-1dip,Large-1dip)
				Factor=1
			Else ' if Giant not in Last Plase go prev
				OpenCol=Col
				OpenRow=Row
			End If
			' position giant Image
			Item.Vw.SetLayoutAnimated(MovTime,OpenCol*Large,OpenRow*Large,(Large*2)-1dip,(Large*2)-1dip)
			Factor=2
			LastRow=Max(LastRow,(OpenRow+1))
		Else ' If Image is normal
			' verify is Imgae overcome the Giant
			Do While Collision(Row,Col,OpenRow,OpenCol)
				' if collision goto to next place
				Col=Col+1
				If Col>=MaxCol Then 
					Col=0
					Row=Row+1
				End If
			Loop
			Item.Vw.SetLayoutAnimated(MovTime,Col*Large,Row*Large,Large-1dip,Large-1dip)
			Factor=1
			LastRow=Max(LastRow,Row)
		End If
		'Item.Vw.SetBitmap(Item.bmp.Resize(Large*Factor,Large*Factor,KeepAspectRatio))
		Item.Vw.SetBitmap(Item.bmp)
		
		Dim Imv As ImageView=Item.Vw
		#if B4A
			Imv.Gravity = Gravity.FILL
		#Else If B4J
			Imv.PreserveRatio = False
		#else if B4i
			Imv.ContentMode = Imv.MODE_FILL
		#End If
		
		'find next free place
		Col=Col+1
		If Col>=MaxCol Then
			Col=0
			Row=Row+1
		End If
	LastItem=Item
	Next
	
	Sc.ScrollViewContentHeight=(LastRow+1)*Large
End Sub

Public Sub setImageWidth(V As Int)
	Large=V
	Invalidate
End Sub

'Width/Heght image
Public Sub getImageWidth As Int
	Return Large
End Sub

#If B4J

Private Sub Image_MouseClicked (EventData As MouseEvent)
	Dim BV As B4XView = Sender
	If EventData.ClickCount=1 Then
		SingleClick=True
		Sleep(300)
		If SingleClick Then Event(BV)
	Else If EventData.ClickCount=2 Then
		SingleClick=False
		Dim ThisItem As TypeImage = BV.tag
		If xui.SubExists(mCallBack,mEventName & "_LongClick",2) Then CallSub3(mCallBack,mEventName & "_LongClick",ThisItem.ID,ThisItem.Open)
	End If
End Sub

#ELSE

Private Sub Image_Click
	Event(Sender)
End Sub

Private Sub Image_LongClick
	Dim BV As B4XView = Sender
	Dim ThisItem As TypeImage = BV.tag
	If xui.SubExists(mCallBack,mEventName & "_LongClick",2) Then CallSub3(mCallBack,mEventName & "_LongClick",ThisItem.ID,ThisItem.Open)
End Sub

#End IF


#Region funzioni

Private Sub Collision(X1 As Int, Y1 As Int, X2 As Int, Y2 As Int) As Boolean
	Dim B As Boolean = False
	
	If (X2+1=X1) And(Y2+1=Y1) Then B=True
	If (X2=X1) And(Y2+1=Y1) Then B=True
	If (X2+1=X1) And(Y2=Y1) Then B=True
	If (X2=X1) And(Y2=Y1) Then B=True
	
	Return b
End Sub

Private Sub Event(BV As B4XView)
	Dim ThisItem As TypeImage = BV.tag
	Dim State As Boolean = ThisItem.Open
	
	For Each Item As TypeImage In ListB4XBitmap
		Item.Open=False
	Next
	
	ThisItem.Open=Not(State)
	Invalidate
	
	If xui.SubExists(mCallBack,mEventName & "_Select",2) Then CallSub3(mCallBack,mEventName & "_Select",ThisItem.ID,ThisItem.Open)
End Sub

#End region